#include "cs.h"
#include "text.h"
#include <stdio.h>
#include <iostream.h>
#include <assert.h>

void
prstat( const char* fn, CSStatus st )
{
    cout << fn << " -> ";
    switch( st )  {
	case csOK: cout << "OK\n"; break;
	case csNOTFOUND: cout << "NOTFOUND\n"; break;
	case csLOCKERROR: cout << "LOCKERROR\n"; break;
    }
}

int
main ()
{
    try {	
	Client client( "localhost", 7000 );
	client.RegisterType( new Text( "", "" ) );
	
	Text* orig = new Text( "Text_Borg", "Surrender immediately. Resistance is futile." );
	
	printf( "orig initialized. text == '%s'\n", orig->GetText().c_str() );
	
	prstat( "client.Add", client.Add( orig ) );
	puts( "Text_Borg added." );
	
	orig->SetText( "" );
	printf( "orig->Text was manually changed to '%s'\n", orig->GetText().c_str() );
//	client.Del( orig );
	
	prstat( "client.Lock", client.Lock( "Text_Borg" ) );
	
	Text* re = (Text*) client.FindName( "Text_Borg" );
	assert( re != NULL );
	printf( "Text_Borg loaded and locked. Text == '%s'\n", re->GetText().c_str() );
    }
    catch( Exception& e) {
	cout << e;
    }
    catch (...) {
	cout << "simpleclient: unhandled exception occured!";
    }
    
    return 0;
}
