#ifndef text_h
#define text_h

#include "cs.h"

    /**
     * This is a small resource that demonstrates the use of resources
     * in the CS system.
     */
class Text : public CSResource
{
 public:
    Text (const string& name, const string& _text) 
	    : CSResource( name ), text( _text )
	{ type = 1; }
    
    virtual CSResource* Clone( const string& name) const
	{ return new Text( text, name ); }

    const string& GetText() const { return text; }
    void SetText( const string& t ) { text = t; }
    
    virtual void Dump( ostream& os )
    {
	os << "Text {\n  name = \"" << GetName() << "\";\n  text = \""
	   << GetText() << "\"; }\n";
    }
	
 protected:
    virtual void WriteData( Socket& s ) { s << text; }
    virtual void ReadData( Socket& s ) { s >> text; }

 private:
    string text;
}; 

#endif
